module pauses
!===============================================================================
contains
!===============================================================================
subroutine pauser(query_string)	!Pause statement
implicit none
  character(*),intent(in)::query_string
  logical ok
  ok=yes_or_no(query_string)
  if(.not.ok) then
    stop
  end if
!===============================================================================
end subroutine pauser
!===============================================================================
logical function yes_or_no(query)
  implicit none
  character(len=80),intent(IN)::query
  character(len=80)::tquery,yorn,ayorn
  character(len=1)::cquery(80)!,outquery(80)
  equivalence (tquery,cquery)
  integer::endquery,i
  logical::ok

  tquery=trim(adjustl(query))		!Delete leading blanks

  endquery=scan(tquery,"?%\"//char(0))-1	!Stop at any of ?%\ or char(0)

  ok=.false.
  do while(.not.ok)
    print *,(cquery(i),i=1,endquery)," (Y for yes, N for no)?"
    read *,yorn

    ayorn=adjustl(yorn)			!Delete leading blanks

    if(scan(ayorn,"nN")==1) then	!Explicitly said NO?
      yes_or_no=.false.
      ok=.true.
    else if(scan(yorn,"yY")==1) then	!Explicity said YES?
      yes_or_no=.true.
      ok=.true.
    end if
    
  end do
  return

end function yes_or_no
!===============================================================================
end module pauses
